/*

Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Appello del 26/02/2007

Tempo a disposizione: 2h 30 min

Scrivere un programma per la gestione della vendita dei  cd presso un negozio di dischi.
Per tenere traccia dei cd presenti, viene utilizzato un vettore di 4 liste, una per ogni genere  di musica.
I cd sono caratterizzati dalle seguenti informazioni: titolo, cantante, codice identificativo del cd, numero di copie,  prezzo, genere del cd.
Per tenere traccia delle vendite  viene utilizzata una tabella allocata dinamicamente avente 4 righe, una per ogni genere di di musica.
Ogni vendita  caratterizzata dal codice fiscale del cliente, dal codice identificativo del cliente, dalla data di vendita e dal genere di musica.
Linserimento di una nuova vendita nella riga relativa al genere di musica  realizzato solo se esiste almeno una copia del cd. Se la copia del cd esiste, il numero di copie viene diminuito.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento di un nuovo cd;
2.Eliminazione di un cd dopo averne stampato il titolo e il nome del cantante;
3.Inserimento di una nuova vendita nella riga relativa al genere di musica  dopo averne verificato la presenza  e aggiornamento del numero di copie dei cd;
4.Visualizzazione delle vendite relative a un genere di musica.

Liberare la memoria allocata dinamicamente.


*/

#include <stdio.h>
#include <stdlib.h>

typedef struct{char titolo[31];
               char cantante[30];
               int c_cd;
               int n_copie;
               float prezzo;
               int genere;
               } cd;


struct atomo{
		cd dato;
        struct atomo *next;
        };

typedef struct{
               char cod_f[17];
               int c_cd;
               char data[11];
               int genere;
               }vendita;


void leggi_cd(cd *pa);
void ins_lista(struct atomo *L[4]);
void elimina(struct atomo *L[4]);
int ric_agg(struct atomo *tl, int codice);
void vend(vendita *V[4],int *N,struct atomo *L[4]);
void visualizza(vendita *V[4],int *N);
void libera_lista(struct atomo **tl);
void menu();



int main(void){

  struct atomo *VL[4];
  vendita *T[4];
  int i,scelta,gen,N[4];

    for(i=0;i<4;i++)
     {VL[i]=NULL;
      T[i]=NULL;
      N[i]=0;
     }

    do{  menu();
    scanf("%d",&scelta);
    switch(scelta){
      case 1: ins_lista(VL);
              break;
      case 2: elimina(VL);
              break;
      case 3: vend(T,N,VL);
              break;
      case 4: visualizza(T,N);
              break;
      default:;
     }
    }while(scelta!=0);

   for(i=0;i<4;i++)
     libera_lista(&VL[i]);

   for(i=0;i<4;i++)
      free(T[i]);
}

void leggi_cd(cd *pa)
{
  printf("\nInserire il titolo del cd(max 30 carateri): ");
  scanf("%s",pa->titolo);
  printf("\nInserisci Cantante: ");
  scanf("%s",pa->cantante);
  printf("\nInserisci il prezzo: ");
  scanf("%f",&pa->prezzo);
  printf("\nInserisci il codice cd: ");
  scanf("%d",&pa->c_cd);
  printf("\nInserisci il codice genere(da 0 a 3): ");
  scanf("%d",&pa->genere);
  printf("Inserisci il numero di copie");
  scanf("%d",&pa->n_copie);
}


void ins_lista(struct atomo *L[4])
{struct atomo *aux;
 cd x;
 int gen;


 leggi_cd(&x);
 gen=x.genere;
 aux=malloc(sizeof(struct atomo));
 if(aux==NULL)
	{printf("\n\aErrore Impossibile allocare nuova memoria");
 	 return;
	}
 aux->dato=x;
 aux->next=L[gen];
 L[gen]=aux;
}

void elimina(struct atomo *L[4])
{struct atomo *aux,*l1,*l2;
 int cod,gen;

 printf("Inserisci il codice cd: ");
 scanf("%d",&cod);
 printf("Inserisci il genere: ");
 scanf("%d",&gen);

 if(L[gen]==NULL)
 {printf("La lista e' vuaota");
  return;
 }

 if(L[gen]->dato.c_cd==cod)
 {aux=L[gen];
  printf("\nTitolo: %s",aux->dato.titolo);
  printf("\nCantante: %s",aux->dato.cantante);
  L[gen]=aux->next;
  free(aux);
  return;
 }

 l2=L[gen];
 l1=l2->next;
 while(l1!=NULL)
 if(l1->dato.c_cd==cod)
	 {
 		printf("\nTitolo: %s",l1->dato.titolo);
  		printf("\nCantante: %s",l1->dato.cantante);
  		l2->next=l1->next;
  		free(l1);
  		return;
 	}
 else{l2=l2->next;
      l1=l1->next;
      }

 printf("L'elemento non esiste");
}


int ric_agg(struct atomo *tl, int cod)
{
 vendita *aux;
 struct atomo *l1,*l2;


 if(tl==NULL)
 {printf("\nla lista e' vuota");
  return 0;
 }

 while(tl!=NULL)
 if(tl->dato.c_cd==cod)
   { if(tl->dato.n_copie>0)
       {tl->dato.n_copie--;
        return 1;
	   }
	 else {printf("Nessuna copia\n");
           return 0;
	      }
   }
 else tl=tl->next;

 printf("\nL'elemento non esiste");
 return 0;
}

void vend(vendita *V[4],int *N,struct atomo *L[4])
{vendita *aux;
 int gen,cod;

 printf("Inserisci il codice cd: ");
 scanf("%d",&cod);
 printf("Inserisci il genere: ");
 scanf("%d",&gen);

 if(ric_agg(L[gen],cod)==0)
	 return;

 aux=realloc(V[gen],sizeof(vendita)*((N[gen])+1));
 if(aux==NULL)
  {printf("Impossibile allocare nuova memoria");
   return;
  }
 V[gen]=aux;
 printf("\nInserire il cod_fisc.: ");
 scanf("%s",V[gen][N[gen]].cod_f);
 printf("\nInserisci la data: ");
 scanf("%s",V[gen][N[gen]].data);
 V[gen][N[gen]].c_cd=cod;
 V[gen][N[gen]].genere=gen;
 N[gen]++;
}


void visualizza(vendita *V[4],int *N)
{int i,gen;
 printf("\nInserire il genere: ");
 scanf("%d",&gen);
 if(N[gen]==0)
 {printf("La categoria e' vuota");
  return;
 }
 for(i=0;i<N[gen];i++)
 {printf("\ncod_fisc.: %s",V[gen][i].cod_f);
  printf("\ndata: %s\n",V[gen][i].data);

 }
}


void libera_lista(struct atomo **tl)
{struct atomo *aux;
 while(*tl!=NULL)
 {aux=*tl;
  *tl=aux->next;
  free(aux);
 }
}

void menu()
{printf("\nPROGRAMMA PER LA GESTIONE DELLA VENDITA DI CD");
 printf("\n\nScegli una tra le seguenti opzioni:");
 printf("\n1) Inserimento di un cd");
 printf("\n2) Eliminazione di un cd");
 printf("\n3) Inserimento di una nuova vendita");
 printf("\n4) Visualizzazione delle vendite");
 printf("\n0) Esci");
 printf("\n\nScelta: ");
}
